
--		spell (EN),		is mount/speedindex,	fly-speed,		in:combat		in:air			outlandonly		icon
--										ground-speed,	water-speed,	in:water		on:ground		can indoor				instant

SmartMount.InitSpells = {
		{'Ghost Wolf',			2,		140,	false,	66,		true,	true,	false,	true,	false,	false,	'Interface\\Icons\\Spell_Nature_SpiritWolf', false},
		{'Levitate',			false,	100,	100,	100,	false,	true,	true,	true,	false,	false,	'Interface\\Icons\\Spell_Holy_LayOnHands', true},
		{'Slow Fall',			false,	100,	100,	false,	false,	false,	true,	true,	false,	false,	'Interface\\Icons\\Spell_Magic_FeatherFall', true},
	}

SmartMount.InitShapeshifts = {
		{'Bear Form',			false,	100,	false,	66,		true,	true,	false,	true,	false,	true,	'Interface\\Icons\\Ability_Racial_BearForm'},
		{'Dire Bear Form',		false,	100,	false,	66,		true,	true,	false,	true,	false,	true,	'Interface\\Icons\\Ability_Racial_BearForm'},
		{'Aquatic Form',		false,	false,	false,	100,	true,	true,	false,	false,	false,	false,	'Interface\\Icons\\Ability_Druid_AquaticForm'},
		{'Cat Form',			false,	100,	false,	66,		true,	true,	false,	true,	false,	true,	'Interface\\Icons\\Ability_Druid_CatForm'},
		{'Travel Form',			2,		140,	false,	false,	true,	false,	false,	true,	false,	false,	'Interface\\Icons\\Ability_Druid_TravelForm'},
		{'Moonkin Form',		false,	100,	false,	66,		true,	true,	false,	true,	false,	true,	'Interface\\Icons\\Spell_Nature_ForceOfNature'},
		{'Tree of Life',		false,	100,	false,	66,		true,	true,	false,	true,	false,	true,	'Interface\\Icons\\Ability_Druid_TreeofLife'},
		{'Flight Form',			5,		false,	160,	false,	false,	false,	true,	true,	true,	false,	'Interface\\Icons\\Ability_Druid_FlightForm'},
		{'Swift Flight Form',	6,		false,	380,	false,	false,	false,	true,	true,	true,	false,	'Interface\\Icons\\Ability_Druid_FlightForm'},
	}

function SmartMount:InitClick()
	self.SpecialSpells = {}

	-- check for spells...
	for _, spell in pairs(self.InitSpells) do
		local locspell = self.SpellLocale[spell[1]]
		
		self.SpecialSpells['spell:' .. spell[1]] = {
			type = 'spell',
			spell = locspell,
			name = locspell,
			can = GetSpellTexture(locspell),
			mount = spell[2],
			land = spell[3],
			fly = spell[4],
			swim = spell[5],
			incombat = spell[6],
			inwater = spell[7],
			inair = spell[8],
			onground = spell[9],
			outlandonly = spell[10],
			inhouse = spell[11],
			icon = spell[12],
			instant = spell[13],
		}
	end -- for
	
	local _, myclass = UnitClass('player')
	if myclass == 'SHAMAN' then
		-- I'm an Shaman
		local name, rank, icon, cost, isFunnel, powerType, castTime, minRange, maxRange = GetSpellInfo(self.SpellLocale['Ghost Wolf'])
		if castTime == 0 then
			self.SpecialSpells['spell:Ghost Wolf'].instant = true
		end -- if
	end -- if
	
	-- check for shapeshift forms
	for _, spell in pairs(self.InitShapeshifts) do
		local locspell = self.SpellLocale[spell[1]]

		local can = false
		for i=1, GetNumShapeshiftForms() do
			local _,name, _ = GetShapeshiftFormInfo(i)
			if name == locspell then
				can = true
			end -- if
		end -- for
		self.SpecialSpells['spell:' .. spell[1]] = {
			type = 'spell',
			spell = locspell,
			name = locspell,
			can = can,
			mount = spell[2],
			land = spell[3],
			fly = spell[4],
			swim = spell[5],
			incombat = spell[6],
			inwater = spell[7],
			inair = spell[8],
			onground = spell[9],
			outlandonly = spell[10],
			inhouse = spell[11],
			icon = spell[12],
			instant = true,
		}
	end -- for
	
	-- special enties
	self.SpecialSpells['special:instantform'] = {
		type = 'special',
		name = self.rock and self.L['Travel, Flight or Swift Flight Form'],
		can = self.SpecialSpells['spell:Travel Form'].can,
		mount = 2,
		land = 140,
		fly = false,
		swim = false,
		incombat = false,
		inwater = false,
		inair = false,
		onground = true,
		outlandonly = false,
		inhouse = false,
		icon = 'Interface\\Icons\\Ability_Hunter_Pathfinding',
	}
	
	-- 'join' flight form
	if self.SpecialSpells['spell:Swift Flight Form'].can then
		-- just say, that the Flight Form has speed 6, and another spell...
		self.SpecialSpells['spell:Flight Form'].spell = self.SpecialSpells['spell:Swift Flight Form'].spell
		self.SpecialSpells['spell:Flight Form'].mount = self.SpecialSpells['spell:Swift Flight Form'].mount
		self.SpecialSpells['spell:Flight Form'].fly = self.SpecialSpells['spell:Swift Flight Form'].fly
		self.SpecialSpells['spell:Flight Form'].can = true
	end
	self.SpecialSpells['spell:Flight Form'].name = self.rock and self.L['Flight / Swift Flight Form']
	self.SpecialSpells['spell:Swift Flight Form'] = nil
	
	-- 'join' bear form
	if self.SpecialSpells['spell:Dire Bear Form'].can then
		-- just say, that the Flight Form has speed 6, and another spell...
		self.SpecialSpells['spell:Bear Form'].spell = self.SpecialSpells['spell:Dire Bear Form'].spell
		self.SpecialSpells['spell:Bear Form'].can = true
	end
	self.SpecialSpells['spell:Bear Form'].name = self.rock and self.L['Bear / Dire Bear Form']
	self.SpecialSpells['spell:Dire Bear Form'] = nil

	-- Hook of the Master Angler
	self.SpecialSpells['special:Hook of the Master Angler'] = {
		type = 'item',
		item = 'item:19979:0:0:0:0:0:0:',
		name = self.SpellLocale['Hook of the Master Angler'],
		spell = self.SpellLocale['Hook of the Master Angler'],
		can = self:WearItem('item:19979:'),
		mount = false,
		land = false,
		fly = false,
		swim = 100,
		incombat = false,
		inwater = true,
		inair = false,
		onground = false,
		outlandonly = false,
		inhouse = false,
		icon = [[Interface\Icons\Trade_Fishing]],
		instant = true,
	}
	
	if self.rock then
		-- update the ListOfMountsCache (profile)
		-- and generate the self.ListOfMounts

		local mountspeed = { [1]={100, false}, [2]={140,false}, [3]={160,false}, [4]={200,false}, [5]={160,160}, [6]={200,380}, [7]={200,410} }

		self.ListOfMounts = {}
	
		-- count the mounts I have	
		local mounts = self:CountMounts(true, false, true)
		for i=1, 7 do
			for _, v in pairs(mounts[i]) do
				local _, itemName, _, itemTexture, _ = GetCompanionInfo("MOUNT", v.slot)
				if type(itemName) ~= 'string' then
					self:dump('mounts['..i..']', v)
					self:dump('itemName', itemName)
					self:dump('itemTexture', itemTexture)
				else
					-- update cache
					self:GetPref('ListOfMountsCache')[v.action] = i..':'..itemName
					--self:SetTablePref('ListOfMountsCache', v.action, i..':'..itemName)
					-- set list
					self.ListOfMounts[v.action] = {
						type = 'MOUNT',
						action = v.action,
						name = itemName,
						slot = v.slot,
						can = true,
						mount = i,
						land = mountspeed[i][1],
						fly = mountspeed[i][2],
						swim = false,
						incombat = false,
						inwater = false,
						inair = false,
						onground = true,
						outlandonly = mountspeed[i][2],
						inhouse = false,
						icon = itemTexture,
					}
				end -- if
			end -- for
		end -- for
	
		for k,v in pairs(self:GetPref('ListOfMountsCache')) do
			local found, _, speed, name = string.find(v, '(%d+):(.*)')
			if not found or string.sub(k, 1, 6) ~= 'MOUNT:' then
				self:GetPref('ListOfMountsCache')[k] = nil
				--self:SetTablePref('ListOfMountsCache', k, nil)
			elseif self.ListOfMounts[k] == nil then
				self.ListOfMounts[k] = {
					action = k,
					name = name,
					spell = name,
					can = false,
					land = mountspeed[tonumber(speed)][1],
					fly = mountspeed[tonumber(speed)][2],
					swim = false,
					incombat = false,
					inwater = false,
					inair = false,
					onground = true,
					outlandonly = mountspeed[tonumber(speed)][2],
					inhouse = false,
					icon = nil,
				}
				-- we can set icon/spell to nil, because of 'can=false'
			end -- if
		end -- for
	
		for k, v in pairs(self.SpecialSpells) do
			v['action'] = k
			self.ListOfMounts[k] = v
		end -- for
		
		for k,v in pairs(self.ListOfMounts) do
			if not v['can'] then
				if string.sub(k, 1, 5) == 'item:' then
					v['icon'] = 'Interface\\AddOns\\SmartMount\\Icons\\Mount_Item'
				elseif k == 'special:Hook of the Master Angler' then
					v['icon'] = 'Interface\\AddOns\\SmartMount\\Icons\\Special_Hook'
				elseif (v.land and v.land > 100) or (v.fly and v.fly > 100) then
					v['icon'] = 'Interface\\AddOns\\SmartMount\\Icons\\Mount_Spell'
				else
					v['icon'] = 'Interface\\AddOns\\SmartMount\\Icons\\Spell'
				end -- if
			end -- if
		end -- do
	end
	
	local hasinstant = false
	for _,v in pairs(self.SpecialSpells) do
		if v.instant then
			hasinstant = true
		end -- if
	end
		self:dump('hasinstant', hasinstant)
	
	self:SetupCheckIsMoving()	
	
	self:PostClick('LeftButton')
	self:PostClick('RightButton')
	self:PostClick('MiddleButton')
	
end

function SmartMount:SetupCheckIsMoving()
--	self.frame_timer = 0
	if self:GetPref('CheckIsMoving') then
		local CheckIsMovingAutoMap = self:GetPref('CheckIsMovingAutoMap')
		self.frame:SetScript("OnUpdate", function(frame, elapsed)
			local x, y = GetPlayerMapPosition('player')
			if CheckIsMovingAutoMap and x == 0 and y == 0 then
				if not WorldMapFrame:IsVisible() then
					SetMapToCurrentZone()
				end -- if
				self.frameLastX = -1
				if self.IsMoving then
					self:dump('IsMoving', nil)
				end
				self.IsMoving = false
			elseif x ~= self.frameLastX or y ~= self.frameLastY then
				self.frameLastX = x
				self.frameLastY = y
				if not self.IsMoving then
					self:dump('IsMoving', true)
				end
				self.IsMoving = true
			else
				if self.IsMoving then
					self:dump('IsMoving', false)
				end
				self.IsMoving = false
			end -- if
--[[		self.frame_timer = self.frame_timer + elapsed
			if self.frame_timer > 2 then
				self.frame_timer = 0
				self:dump('IsMoving', 'ping x='..x..', y='..y)
			end -- if  --]]
		end)
	else
		self.frame:SetScript("OnUpdate", nil)
		self.IsMoving = false
	end -- if
end

function SmartMount:HijackBindings(showmessage)
    self:dump('hijack');
	
	if showmessage then
		DEFAULT_CHAT_FRAME:AddMessage('|cff3fcf26SmartMount|r: Please press the key again to use SmartMount.')
	end -- if

	-- normal bindings
	ClearOverrideBindings(SmartMount_Button)
	
	local key1, key2 = GetBindingKey('SMARTMOUNT_MOUNTORCONFIG')
	if key1 then
		SetOverrideBindingClick(SmartMount_Button, true, key1, 'SmartMount_Button')
	end --if
	if key2 then
		SetOverrideBindingClick(SmartMount_Button, true, key2, 'SmartMount_Button')
	end --if
end


function SmartMount:PreClick(btn)
self:dump('pc', btn)
	local config

	if btn == 'MiddleButton' then
		config = 3
	elseif btn == 'RightButton' then
		config = 2
	else -- if btn == 'LeftButton' then
		config = 1
	end -- if

	local mounted = nil
	
	if IsMounted() then
		mounted = 'regular';
	end -- if
	
	for _, spell in pairs(self.SpecialSpells) do
		if spell['spell'] and spell['mount'] then
			self:dump(spell['spell'], UnitBuff('player', spell['spell']), false, true)
		end
		if spell['spell'] and spell['mount'] and UnitBuff('player', spell['spell']) then
			mounted = spell['spell']
		end -- if
	end -- for

	local name, mode
	if InCombatLockdown() then
		name = 'combat'
	elseif IsSwimming() then
		name = 'swim'
	elseif IsFlying() or IsFalling() then
		name = 'fly'
	else
		name = 'land'
	end -- if
	
	local _, myclass = UnitClass('player')
	if not mounted and myclass == 'DRUID' then
		for i=1, GetNumShapeshiftForms() do
			local _, name, active, _ = GetShapeshiftFormInfo(i)
			self:dump(i, {name, active})
			if active then
				mounted = name
			end -- if
		end -- for
	end -- if

	self:dump('preclick', {cfg = config, name = name, mounted = mounted})

	if mounted then
		mode = 'dis'
		
		if not self:GetPref('c'..config..'-'..name..'-dis-do') then
			-- cancel here, cause we would'nt dismount
			if name ~= 'combat' then
				-- if in combat: don't change button; otherwise: don't do anything
				self:SetAttributes(config, {})
			end -- if
			return
		end
	
		if name == 'fly' and self:GetPref('c'..config..'-'..name..'-dis-do-groundonly') and IsFlying() then
			-- cancel here, cause we would'nt dismount
			self:SetAttributes(config, {})
			return
		end
	
	    if mounted == 'regular' then
			Dismount()
		else
--			CancelUnitBuff('player', mounted)
			self:SetAttributes(config, {type='spell', spell=mounted})
			return
		end -- if
	else
		mode = 'mnt'
	end -- if
	
	self:dump('preclick-mode:', mode)
	
	if name == 'combat' then
		-- cancel here, cause we can't do anything
		return
	end -- if
		
	local chgbutton = self:GetMount('c'..config..'-'..name..'-'..mode..'-try', name, false) or {}
	-- or => if nothing found: nothing

	self:dump('preclick-button', chgbutton)
	
	self:SetAttributes(config, chgbutton)
end

function SmartMount:PostClick(btn)
	if btn == 'MiddleButton' then
		config = 3
	elseif btn == 'RightButton' then
		config = 2
	else -- if btn == 'LeftButton' then
		config = 1
	end -- if
    self:dump('postclick', config)

	if not InCombatLockdown() then
		local chgbutton = self:GetMount('c'..config..'-combat-mnt-try', 'combat', true) or {}
		-- or => if nothing found: nothing

		self:dump('postclick-button', chgbutton)
	
		self:SetAttributes(config, chgbutton)
	end
end

function SmartMount:SetAttributes(config, attr)
	if attr['type'] == 'MOUNT' or attr['type'] == 'CRITTER' then
		CallCompanion(attr['type'], attr['slot'])
	else
		SmartMount_Button:SetAttribute('type'..config, attr['type'])
		SmartMount_Button:SetAttribute('spell'..config, attr['spell'])
		SmartMount_Button:SetAttribute('item'..config, attr['item'])
	end -- if
end

function SmartMount:GetMount(prefix, name, ignoremoving)
	local IsMoving = self.IsMoving
	if ignoremoving then
		IsMoving = false
	end
	
	for i=1, 3 do
		local mount = self:GetPref(prefix .. i)

		--self:dump(prefix..i..name, mount)

		local result = nil
		if not mount or mount == 'off' then
			return nil -- found nothing: do nothing
		elseif mount == 'rnd_fast' and IsOutdoors() then
			result = self:GetRandomMount(self:IsInOutland(), IsMoving)
		elseif mount == 'rnd_all' and IsOutdoors() then
			result = self:GetAnyRandomMount(self:IsInOutland(), IsMoving)
		elseif mount == 'rnd_pet' then
			local useable = {}
			for slot = 1 , GetNumCompanions('CRITTER') do
				local _, _, creatureSpellID, _, issummoned = GetCompanionInfo('CRITTER', slot)
				if not issummoned and not self:GetPlayerPref('ExcludedMiniPets')[creatureSpellID] then
					table.insert(useable, {
						type = 'CRITTER',
						slot = slot,
					})
				end -- if
			end -- for
			if #useable > 0 then
				result = useable[math.random(#useable)]
			end -- if
		elseif string.sub(mount, 1, 5) == 'item:' then
			if self:WearItem(mount) then
				result = {
					type = 'item',
					item = mount,
				}
			end -- if
		elseif ( string.sub(mount, 1, 6) == 'MOUNT:' and IsOutdoors() and not IsMoving ) or string.sub(mount, 1, 8) == 'CRITTER:' then
			self:dump(mount, self.ListOfMounts[mount])
			if self.ListOfMounts[mount].can then
				result = {
					type = self.ListOfMounts[mount].type,
					slot = self.ListOfMounts[mount].slot,
				}
			end -- if
		elseif self.SpecialSpells[mount] then
			-- something special (which is in SpecialSpells)
			if 
				(
					(self.SpecialSpells[mount].type == 'spell' and self.SpecialSpells[mount].can) or
					(self.SpecialSpells[mount].type == 'item' and self:WearItem(self.SpecialSpells[mount].item))
				)
					and
				(
					not self.SpecialSpells[mount].outlandonly or self:IsInOutland()
				)
					and
				(
					self.SpecialSpells[mount].inhouse or IsOutdoors()
				)
					and
				(
					self.SpecialSpells[mount].instant or not IsMoving
				)
					and
				(
					(name == 'swim' and self.SpecialSpells[mount].inwater) or
					(name == 'fly' and self.SpecialSpells[mount].inair) or
					(name == 'land' and self.SpecialSpells[mount].onground) or
					(name == 'combat' and self.SpecialSpells[mount].incombat)
				)
			then
				result = self.SpecialSpells[mount]
			end -- if
		end -- if
		if result then
			return result
		end -- if
	end
	return nil
end

function SmartMount:GetRandomMount(inoutland, IsMoving)
	-- get 'regular' mounts
	local mounts = self:CountMounts(false, IsMoving)
	
	-- max speed (outland or not)
	local maxspeed = 4
	if inoutland then
		maxspeed = 7
	end -- if
	
	self:dump('mounts_avail', mounts)
	
	-- pick speed category
	for speed = maxspeed, 1, -1 do
		if #(mounts[speed]) > 0 then
			self:dump('mounts_sele', mounts[speed])
			return mounts[speed][math.random(#(mounts[speed]))]
		end
	end -- for
	
	return nil
end

function SmartMount:GetAnyRandomMount(inoutland, IsMoving)
	-- get 'regular' mounts
	local mounts = self:CountMounts(false, IsMoving)
	
	-- max speed (outland or not)
	local maxspeed = 4
	if inoutland then
		maxspeed = 7
	end -- if
	
	self:dump('mounts_biglist', mounts)
	
	local biglist = {}
	
	-- pick speed category
	for speed = maxspeed, 1, -1 do
		for _, v in pairs(mounts[speed]) do
			table.insert(biglist, v)
		end -- for
	end -- for
	
	if #biglist > 0 then
		return biglist[math.random(#biglist)]
	end -- if
	
	return nil
end

function SmartMount:CountMounts(withoutSpells, IsMoving, noExcl)
	local mounts = { {}, {}, {}, {}, {}, {}, {} }
	local excl = noExcl or self:GetPlayerPref('ExcludedMounts')

	if not IsMoving then
		for slot = 1, GetNumCompanions("MOUNT") do
			local creatureID, creatureName, creatureSpellID, icon, issummoned = GetCompanionInfo("MOUNT", slot)
			self:dump('mount', {creatureID, creatureName, creatureSpellID, issummoned})
			if noExcl or not excl[creatureSpellID] then
				-- only if not excluded by the user
				local speed = self.Mounts[tonumber(creatureSpellID)]
				if speed then
					table.insert(mounts[speed], { type = 'MOUNT', slot = slot, companionid =  creatureSpellID, action = 'MOUNT:' .. creatureSpellID} )
				end -- if
			end -- if
		end -- for
	end -- if
	
	if not withoutSpells then
		for name, spell in pairs(self.SpecialSpells) do
			if spell.can and spell['mount'] and ( spell.instant or not IsMoving ) then
				table.insert(mounts[spell['mount']], spell)
			end -- if
		end -- for
	end -- if

	return mounts
end

function SmartMount:WearItem(item)
	-- search in bags
	for bag = 0, NUM_BAG_FRAMES do
		for slot = 1, GetContainerNumSlots(bag) do
			local link = GetContainerItemLink(bag, slot)
			if link and string.find(link, item) then
				return true
			end -- if
		end -- for
	end -- for
	
	-- search on me
	for slot = 1, 39 do
		local link = GetInventoryItemLink('player', slot)
		if link and string.find(link, item) then
			return true
		end -- if
	end -- for
	return false
end


function SmartMount:IsInOutland()
--self:dump('flyable', self.spellNameColdWeatherFlying)
	-- check for flyable area
	if not IsFlyableArea() then
		-- not flyable!
--self:dump('flyable', 'no: not in this area')
		return false
	end -- if

	local zone = GetZoneText()
	if (zone == 'Dalaran' or zone == self.SpellLocale['Wintergrasp']) and GetSubZoneText() ~= self.SpellLocale['Krasus\' Landing'] then
		-- in Darlaran (and not in Krasus' Landing) or in Wintergrasp: no flying allowed
		-- thanks to TooGStyle
--self:dump('flyable', 'no: darlaran|wintergrasp')
		return false
	end -- if

	if GetSpellInfo(self.spellNameColdWeatherFlying) then
--self:dump('flyable', 'yes: i have CWF')
		-- with cold weather flying we can fly everywhere
		return true
	end -- if

	-- here: flyable area AND no cold weather flying
	-- means: don't fly in northrend
	--local zone = GetZoneText()
	for _,name in pairs({GetMapZones(4)}) do
		if(name == zone) then
--self:dump('flyable', 'no: no CWF and in Northrend')
			return false
		end -- if
	end -- for
--self:dump('flyable', 'yes: no CWF and not in Northrend')
	return true
end

SmartMount.Mounts = {
	-- Paladin, Warlock & Deathknight
	[13819] = 3, -- Warhorse
	[23214] = 4, -- Charger
	[1710] = 3, -- Felsteed
	[23161] = 4, -- Dreadsteed
	[48778] = 4, -- Acherus Deathcharger, Lvl 55 
	-- Fixes
	[17229] = 4, -- Reins of the Winterspring Frostsaber, Lvl 60
	[58983] = 4, -- Big Blizzard Bear, Lvl 60
	-- 1 = Riding Skill 0 / Speed 100% (±0%)
	[6896] = 1, -- Harness: Black Ram, Lvl 40
	[6897] = 1, -- Harness: Blue Ram, Lvl 40
	[10787] = 1, -- Reins of the Night saber, Lvl 40
	[10792] = 1, -- Reins of the Spotted Nightsaber, Lvl 40
	[18363] = 1, -- Kodo Mount, Lvl 40
	[30174] = 1, -- Riding Turtle, Lvl 1
	[42692] = 1, -- Rickety Magic Broom, Lvl 1
	[52649] = 1, -- Swift Ebonweave Carpet, Lvl 70
	[61309] = 1, -- Magnificent Flying Carpet, Lvl 70
	[61451] = 1, -- Flying Carpet, Lvl 70
	-- 3 = Riding Skill 75 / Speed +60%
	[458] = 3, -- Brown Horse Bridle, Lvl 30
	[470] = 3, -- Black Stallion Bridle, Lvl 30
	[472] = 3, -- Pinto Bridle, Lvl 30
	[580] = 3, -- Horn of the Timber Wolf, Lvl 30
	[6648] = 3, -- Chestnut Mare Bridle, Lvl 30
	[6653] = 3, -- Horn of the Dire Wolf, Lvl 30
	[6654] = 3, -- Horn of the Brown Wolf, Lvl 30
	[6777] = 3, -- Gray Ram, Lvl 30
	[6898] = 3, -- White Ram, Lvl 30
	[6899] = 3, -- Brown Ram, Lvl 30
	[8394] = 3, -- Reins of the Striped Frostsaber, Lvl 30
	[8395] = 3, -- Whistle of the Emerald Raptor, Lvl 30
	[10789] = 3, -- Reins of the Spotted Frostsaber, Lvl 30
	[10793] = 3, -- Reins of the Striped Nightsaber, Lvl 30
	[10796] = 3, -- Whistle of the Turquoise Raptor, Lvl 30
	[10799] = 3, -- Whistle of the Violet Raptor, Lvl 30
	[10873] = 3, -- Red Mechanostrider, Lvl 30
	[10969] = 3, -- Blue Mechanostrider, Lvl 30
	[17453] = 3, -- Green Mechanostrider, Lvl 30
	[17454] = 3, -- Unpainted Mechanostrider, Lvl 30
	[17462] = 3, -- Red Skeletal Horse, Lvl 30
	[17463] = 3, -- Blue Skeletal Horse, Lvl 30
	[17464] = 3, -- Brown Skeletal Horse, Lvl 30
	[18989] = 3, -- Gray Kodo, Lvl 30
	[18990] = 3, -- Brown Kodo, Lvl 30
	[22717] = 3, -- Black War Steed Bridle, Lvl 55
	[22718] = 3, -- Black War Kodo, Lvl 55
	[22719] = 3, -- Black Battlestrider, Lvl 55
	[22720] = 3, -- Black War Ram, Lvl 55
	[22721] = 3, -- Whistle of the Black War Raptor, Lvl 55
	[22722] = 3, -- Red Skeletal Warhorse, Lvl 55
	[22723] = 3, -- Reins of the Black War Tiger, Lvl 55
	[22724] = 3, -- Horn of the Black War Wolf, Lvl 55
	-- [25953] = 3, -- Blue Qiraji Resonating Crystal, Lvl 60
	-- [26054] = 3, -- Red Qiraji Resonating Crystal, Lvl 60
	-- [26055] = 3, -- Yellow Qiraji Resonating Crystal, Lvl 60
	-- [26056] = 3, -- Green Qiraji Resonating Crystal, Lvl 60
	[34406] = 3, -- Brown Elekk, Lvl 30
	[34795] = 3, -- Red Hawkstrider, Lvl 30
	[35018] = 3, -- Purple Hawkstrider, Lvl 30
	[35020] = 3, -- Blue Hawkstrider, Lvl 30
	[35022] = 3, -- Black Hawkstrider, Lvl 30
	[35710] = 3, -- Gray Elekk, Lvl 30
	[35711] = 3, -- Purple Elekk, Lvl 30
	[42680] = 3, -- Old Magic Broom, Lvl 40
	[42776] = 3, -- Reins of the Spectral Tiger, Lvl 30
	[43899] = 3, -- Brewfest Ram, Lvl 30
	[47977] = 3, -- Magic Broom, Lvl 30
	[48025] = 3, -- The Horseman's Reins, Lvl 60
	-- 4 = Riding Skill 150 / Speed +100%
	[15779] = 4, -- White Mechanostrider Mod B, Lvl 60
	[16055] = 4, -- Reins of the Nightsaber, Lvl 60
	[16056] = 4, -- Reins of the Ancient Frostsaber, Lvl 60
	[16080] = 4, -- Horn of the Red Wolf, Lvl 60
	[16081] = 4, -- Horn of the Arctic Wolf, Lvl 60
	[16082] = 4, -- Palomino Bridle, Lvl 60
	[16083] = 4, -- White Stallion Bridle, Lvl 60
	[16084] = 4, -- Whistle of the Mottled Red Raptor, Lvl 60
	[17450] = 4, -- Whistle of the Ivory Raptor, Lvl 60
	[17459] = 4, -- Icy Blue Mechanostrider Mod A, Lvl 60
	[17460] = 4, -- Frost Ram, Lvl 60
	[17461] = 4, -- Black Ram, Lvl 60
	[17465] = 4, -- Green Skeletal Warhorse, Lvl 60
	[17481] = 4, -- Deathcharger's Reins, Lvl 60
	[18991] = 4, -- Green Kodo, Lvl 60
	[18992] = 4, -- Teal Kodo, Lvl 60
	[22717] = 4, -- Black War Steed Bridle, Lvl 60
	[22718] = 4, -- Black War Kodo, Lvl 60
	[22719] = 4, -- Black Battlestrider, Lvl 60
	[22720] = 4, -- Black War Ram, Lvl 60
	[22721] = 4, -- Whistle of the Black War Raptor, Lvl 60
	[22722] = 4, -- Red Skeletal Warhorse, Lvl 60
	[22723] = 4, -- Reins of the Black War Tiger, Lvl 60
	[22724] = 4, -- Horn of the Black War Wolf, Lvl 60
	[23219] = 4, -- Reins of the Swift Mistsaber, Lvl 60
	[23221] = 4, -- Reins of the Swift Frostsaber, Lvl 60
	[23222] = 4, -- Swift Yellow Mechanostrider, Lvl 60
	[23223] = 4, -- Swift White Mechanostrider, Lvl 60
	[23225] = 4, -- Swift Green Mechanostrider, Lvl 60
	[23227] = 4, -- Swift Palomino, Lvl 60
	[23228] = 4, -- Swift White Steed, Lvl 60
	[23229] = 4, -- Swift Brown Steed, Lvl 60
	[23238] = 4, -- Swift Brown Ram, Lvl 60
	[23239] = 4, -- Swift Gray Ram, Lvl 60
	[23240] = 4, -- Swift White Ram, Lvl 60
	[23241] = 4, -- Swift Blue Raptor, Lvl 60
	[23242] = 4, -- Swift Olive Raptor, Lvl 60
	[23243] = 4, -- Swift Orange Raptor, Lvl 60
	[23246] = 4, -- Purple Skeletal Warhorse, Lvl 60
	[23247] = 4, -- Great White Kodo, Lvl 60
	[23248] = 4, -- Great Gray Kodo, Lvl 60
	[23249] = 4, -- Great Brown Kodo, Lvl 60
	[23250] = 4, -- Horn of the Swift Brown Wolf, Lvl 60
	[23251] = 4, -- Horn of the Swift Timber Wolf, Lvl 60
	[23252] = 4, -- Horn of the Swift Gray Wolf, Lvl 60
	[23338] = 4, -- Reins of the Swift Stormsaber, Lvl 60
	[23509] = 4, -- Horn of the Frostwolf Howler, Lvl 60
	[23510] = 4, -- Stormpike Battle Charger, Lvl 60
	[24242] = 4, -- Swift Razzashi Raptor, Lvl 60
	[24252] = 4, -- Swift Zulian Tiger, Lvl 60
	-- [26656] = 4, -- Black Qiraji Resonating Crystal, Lvl 60
	[33660] = 4, -- Swift Pink Hawkstrider, Lvl 60
	[34790] = 4, -- Reins of the Dark War Talbuk, Lvl 60
	[34896] = 4, -- Reins of the Cobalt War Talbuk, Lvl 60
	[34897] = 4, -- Reins of the White War Talbuk, Lvl 60
	[34898] = 4, -- Reins of the Silver War Talbuk, Lvl 60
	[34899] = 4, -- Reins of the Tan War Talbuk, Lvl 60
	[35025] = 4, -- Swift Green Hawkstrider, Lvl 60
	[35027] = 4, -- Swift Purple Hawkstrider, Lvl 60
	[35028] = 4, -- Swift Warstrider, Lvl 60
	[35712] = 4, -- Great Green Elekk, Lvl 60
	[35713] = 4, -- Great Blue Elekk, Lvl 60
	[35714] = 4, -- Great Purple Elekk, Lvl 60
	[36702] = 4, -- Fiery Warhorse's Reins, Lvl 70
	[39315] = 4, -- Reins of the Cobalt Riding Talbuk, Lvl 60
	[39316] = 4, -- Reins of the Dark Riding Talbuk, Lvl 60
	[39317] = 4, -- Reins of the Silver Riding Talbuk, Lvl 60
	[39318] = 4, -- Reins of the Tan Riding Talbuk, Lvl 60
	[39319] = 4, -- Reins of the White Riding Talbuk, Lvl 60
	[41252] = 4, -- Reins of the Raven Lord, Lvl 70
	[42668] = 4, -- Swift Magic Broom, Lvl 60
	[42777] = 4, -- Reins of the Swift Spectral Tiger, Lvl 60
	[43688] = 4, -- Amani War Bear, Lvl 70
	[43900] = 4, -- Swift Brewfest Ram, Lvl 60
	[46628] = 4, -- Swift White Hawkstrider, Lvl 60
	[48027] = 4, -- Reins of the Black War Elekk, Lvl 60
	[49322] = 4, -- Swift Zhevra, Lvl 60
	[49379] = 4, -- Great Brewfest Kodo, Lvl 60
	[51412] = 4, -- Big Battle Bear, Lvl 60
	[55531] = 4, -- Mechano-hog, Lvl 80
	[59785] = 4, -- Reins of the Black War Mammoth, Lvl 60
	[59788] = 4, -- Reins of the Black War Mammoth, Lvl 60
	[59791] = 4, -- Reins of the Wooly Mammoth, Lvl 60
	[59793] = 4, -- Reins of the Wooly Mammoth, Lvl 60
	[59797] = 4, -- Reins of the Ice Mammoth, Lvl 60
	[59799] = 4, -- Reins of the Ice Mammoth, Lvl 60
	[60114] = 4, -- Reins of the Armored Brown Bear, Lvl 60
	[60116] = 4, -- Reins of the Armored Brown Bear, Lvl 60
	[60424] = 4, -- Mekgineer's Chopper, Lvl 80
	[61425] = 4, -- Reins of the Traveler's Tundra Mammoth, Lvl 60
	[61447] = 4, -- Reins of the Traveler's Tundra Mammoth, Lvl 60
	[61469] = 4, -- Reins of the Grand Ice Mammoth, Lvl 60
	[61470] = 4, -- Reins of the Grand Ice Mammoth, Lvl 60
	-- 5 = Riding Skill 225 / Speed +60%/+60%
	[32235] = 5, -- Golden Gryphon, Lvl 70
	[32239] = 5, -- Ebon Gryphon, Lvl 70
	[32240] = 5, -- Snowy Gryphon, Lvl 70
	[32243] = 5, -- Tawny Wind Rider, Lvl 70
	[32244] = 5, -- Blue Wind Rider, Lvl 70
	[32245] = 5, -- Green Wind Rider, Lvl 70
	[42667] = 5, -- Flying Broom, Lvl 70
	[44153] = 5, -- Flying Machine Control, Lvl 70
	[46197] = 5, -- X-51 Nether-Rocket, Lvl 70
	[54729] = 5, -- Winged Steed of the Ebon Blade, Lvl 70
	-- 6 = Riding Skill 300 / Speed +100%/+280%
	[32242] = 6, -- Swift Blue Gryphon, Lvl 70
	[32246] = 6, -- Swift Red Wind Rider, Lvl 70
	[32289] = 6, -- Swift Red Gryphon, Lvl 70
	[32290] = 6, -- Swift Green Gryphon, Lvl 70
	[32292] = 6, -- Swift Purple Gryphon, Lvl 70
	[32295] = 6, -- Swift Green Wind Rider, Lvl 70
	[32296] = 6, -- Swift Yellow Wind Rider, Lvl 70
	[32297] = 6, -- Swift Purple Wind Rider, Lvl 70
	[39798] = 6, -- Green Riding Nether Ray, Lvl 70
	[39800] = 6, -- Red Riding Nether Ray, Lvl 70
	[39801] = 6, -- Purple Riding Nether Ray, Lvl 70
	[39802] = 6, -- Silver Riding Nether Ray, Lvl 70
	[39803] = 6, -- Blue Riding Nether Ray, Lvl 70
	[41513] = 6, -- Reins of the Onyx Netherwing Drake, Lvl 70
	[41514] = 6, -- Reins of the Azure Netherwing Drake, Lvl 70
	[41515] = 6, -- Reins of the Cobalt Netherwing Drake, Lvl 70
	[41516] = 6, -- Reins of the Purple Netherwing Drake, Lvl 70
	[41517] = 6, -- Reins of the Veridian Netherwing Drake, Lvl 70
	[41518] = 6, -- Reins of the Violet Netherwing Drake, Lvl 70
	[42668] = 6, -- Swift Flying Broom, Lvl 70
	[43927] = 6, -- Cenarion War Hippogryph, Lvl 70
	[44151] = 6, -- Turbo-Charged Flying Machine Control, Lvl 70
	[44744] = 6, -- Merciless Nether Drake, Lvl 70
	[46199] = 6, -- X-51 Nether-Rocket X-TREME, Lvl 70
	[58615] = 6, -- Brutal Nether Drake, Lvl 70
	[59569] = 6, -- Reins of the Bronze Drake, Lvl 70
	[59570] = 6, -- Reins of the Red Drake, Lvl 70
	[59650] = 6, -- Reins of the Black Drake, Lvl 70
	[59996] = 6, -- Reins of the Blue Proto-Drake, Lvl 80
	[60025] = 6, -- Reins of the Albino Drake, Lvl 70
	[61229] = 6, -- Armored Snowy Gryphon, Lvl 70
	[61230] = 6, -- Armored Blue Wind Rider, Lvl 70
	-- 7 = Riding Skill 310 / Speed +100%/+310%
	[37015] = 7, -- Swift Nether Drake, Lvl 70
	[40192] = 7, -- Ashes of Al'ar, Lvl 70
	[49193] = 7, -- Vengeful Nether Drake, Lvl 70
}
